//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	$Id: ui_root.cpp,v 1.3 2005/11/24 20:09:23 dj_jl Exp $
//**
//**	Copyright (C) 1999-2002 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**
//**************************************************************************

// HEADER FILES ------------------------------------------------------------

#include "gamedefs.h"
#include "ui.h"

// MACROS ------------------------------------------------------------------

// TYPES -------------------------------------------------------------------

// EXTERNAL FUNCTION PROTOTYPES --------------------------------------------

// PUBLIC FUNCTION PROTOTYPES ----------------------------------------------

// PRIVATE FUNCTION PROTOTYPES ---------------------------------------------

// EXTERNAL DATA DECLARATIONS ----------------------------------------------

// PUBLIC DATA DEFINITIONS -------------------------------------------------

IMPLEMENT_CLASS(V, RootWindow);

VRootWindow *GRoot;

// PRIVATE DATA DEFINITIONS ------------------------------------------------

// CODE --------------------------------------------------------------------

//==========================================================================
//
//	VRootWindow::VRootWindow
//
//==========================================================================

VRootWindow::VRootWindow(void)
{
	WindowType = WIN_Root;
}

//==========================================================================
//
//	VRootWindow::Init
//
//==========================================================================

void VRootWindow::Init(void)
{
	Super::Init(NULL);
	SetSize(320, 200);
}

//==========================================================================
//
//	VRootWindow::PaintWindows
//
//==========================================================================

void VRootWindow::PaintWindows(void)
{
	DrawTree();
}

//==========================================================================
//
//	VRootWindow::TickWindows
//
//==========================================================================

void VRootWindow::TickWindows(float DeltaTime)
{
	TickTree(DeltaTime);
}

//==========================================================================
//
//	VRootWindow::StaticInit
//
//==========================================================================

void VRootWindow::StaticInit()
{
	guard(VRootWindow::StaticInit);
	GRoot = (VRootWindow*)StaticSpawnObject(StaticClass(), PU_STRING);
	GRoot->Init();
	clpr.SetGlobal("GRoot", (int)GRoot);
	unguard;
}

//==========================================================================
//
//
//
//==========================================================================

//**************************************************************************
//
//	$Log: ui_root.cpp,v $
//	Revision 1.3  2005/11/24 20:09:23  dj_jl
//	Removed unused fields from Object class.
//	
//	Revision 1.2  2004/08/21 15:03:07  dj_jl
//	Remade VClass to be standalone class.
//	
//	Revision 1.1  2002/05/29 16:51:50  dj_jl
//	Started a work on native Window classes.
//	
//	Revision 1.4  2002/05/18 16:56:35  dj_jl
//	Added FArchive and FOutputDevice classes.
//	
//**************************************************************************
